From 9dee38402923238b77a0e9010eb0380849b840ae Mon Sep 17 00:00:00 2001
From: Greg Hogan <code@greghogan.com>
Date: Thu, 11 Mar 2021 20:53:15 +0000
Subject: [PATCH 2/2] gnu: abseil-cpp: Patch sterror_test.

* gnu/packages/patches/abseil-cpp-fix-gtest.patch: Renamed file.
* gnu/packages/patches/abseil-cpp-fix-strerror_test.patch: New file.
* gnu/local.mk (dist_patch_DATA): Rename / add files.
* gnu/packages/cpp.scm (abseil-cpp)[source]: Use files.
---
 gnu/local.mk                                  |  3 +-
 gnu/packages/cpp.scm                          |  5 ++-
 ...p-fix.patch => abseil-cpp-fix-gtest.patch} |  0
 .../abseil-cpp-fix-strerror_test.patch        | 42 +++++++++++++++++++
 4 files changed, 48 insertions(+), 2 deletions(-)
 rename gnu/packages/patches/{abseil-cpp-fix.patch => abseil-cpp-fix-gtest.patch} (100%)
 create mode 100644 gnu/packages/patches/abseil-cpp-fix-strerror_test.patch

diff --git a/gnu/local.mk b/gnu/local.mk
index 3ee670d7ff..8ea8767347 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -787,7 +787,8 @@ dist_patch_DATA =						\
   %D%/packages/patches/abcl-fix-build-xml.patch	\
   %D%/packages/patches/ableton-link-system-libraries-debian.patch	\
   %D%/packages/patches/abiword-explictly-cast-bools.patch	\
-  %D%/packages/patches/abseil-cpp-fix.patch			\
+  %D%/packages/patches/abseil-cpp-fix-gtest.patch		\
+  %D%/packages/patches/abseil-cpp-fix-strerror_test.patch	\
   %D%/packages/patches/adb-add-libraries.patch			\
   %D%/packages/patches/aegis-constness-error.patch         	\
   %D%/packages/patches/aegis-perl-tempdir1.patch           	\
diff --git a/gnu/packages/cpp.scm b/gnu/packages/cpp.scm
index e659e378f9..7b8b4ce8b0 100644
--- a/gnu/packages/cpp.scm
+++ b/gnu/packages/cpp.scm
@@ -689,7 +689,10 @@ point and then, after each tween step, plugging back the result.")
                (base32
                 "1p4djhm1f011ficbjjxx3n8428p8481p20j4glpaawnpsi362hkl"))
               ;; Remove after next googletest release and update.
-              (patches (search-patches "abseil-cpp-fix.patch"))))
+              (patches
+               (search-patches
+                "abseil-cpp-fix-gtest.patch"
+                "abseil-cpp-fix-strerror_test.patch"))))
     (build-system cmake-build-system)
     (arguments
      `(#:configure-flags (list "-DBUILD_SHARED_LIBS=ON"
diff --git a/gnu/packages/patches/abseil-cpp-fix.patch b/gnu/packages/patches/abseil-cpp-fix-gtest.patch
similarity index 100%
rename from gnu/packages/patches/abseil-cpp-fix.patch
rename to gnu/packages/patches/abseil-cpp-fix-gtest.patch
diff --git a/gnu/packages/patches/abseil-cpp-fix-strerror_test.patch b/gnu/packages/patches/abseil-cpp-fix-strerror_test.patch
new file mode 100644
index 0000000000..726149b015
--- /dev/null
+++ b/gnu/packages/patches/abseil-cpp-fix-strerror_test.patch
@@ -0,0 +1,42 @@
+From e2b1bab19a782cb62bb010d1c2925ab7314fb113 Mon Sep 17 00:00:00 2001
+diff --git a/absl/base/internal/strerror.cc b/absl/base/internal/strerror.cc
+index d66ba120..0d6226fd 100644
+--- a/absl/base/internal/strerror.cc
++++ b/absl/base/internal/strerror.cc
+@@ -51,7 +51,6 @@ const char* StrErrorAdaptor(int errnum, char* buf, size_t buflen) {
+ }
+ 
+ std::string StrErrorInternal(int errnum) {
+-  absl::base_internal::ErrnoSaver errno_saver;
+   char buf[100];
+   const char* str = StrErrorAdaptor(errnum, buf, sizeof buf);
+   if (*str == '\0') {
+@@ -76,6 +75,7 @@ std::array<std::string, kSysNerr>* NewStrErrorTable() {
+ }  // namespace
+ 
+ std::string StrError(int errnum) {
++  absl::base_internal::ErrnoSaver errno_saver;
+   static const auto* table = NewStrErrorTable();
+   if (errnum >= 0 && errnum < static_cast<int>(table->size())) {
+     return (*table)[errnum];
+diff --git a/absl/base/internal/strerror_test.cc b/absl/base/internal/strerror_test.cc
+index a53da97f..e32d5b5c 100644
+--- a/absl/base/internal/strerror_test.cc
++++ b/absl/base/internal/strerror_test.cc
+@@ -62,12 +62,14 @@ TEST(StrErrorTest, MultipleThreads) {
+       ++counter;
+       errno = ERANGE;
+       const std::string value = absl::base_internal::StrError(i);
++      // EXPECT_* could change errno. Stash it first.
++      int check_err = errno;
++      EXPECT_THAT(check_err, Eq(ERANGE));
+       // Only the GNU implementation is guaranteed to provide the
+       // string "Unknown error nnn". POSIX doesn't say anything.
+       if (!absl::StartsWith(value, "Unknown error ")) {
+-        EXPECT_THAT(absl::base_internal::StrError(i), Eq(expected_strings[i]));
++        EXPECT_THAT(value, Eq(expected_strings[i]));
+       }
+-      EXPECT_THAT(errno, Eq(ERANGE));
+     }
+   };
+ 
-- 
2.30.2

